HDU 3853 LOOPS (概率DP)

网友投稿 521 2022-08-26

HDU 3853 LOOPS (概率DP)

HDU 3853 LOOPS (概率DP)

Problem Description

Akemi Homura is a Mahou Shoujo (Puella Magi/Magical Girl).Homura wants to help her friend Madoka save the world. But because of the plot of the Boss Incubator, she is trapped in a labyrinth called LOOPS.

The planform of the LOOPS is a rectangle of R*C grids. There is a portal in each grid except the exit grid. It costs Homura 2 magic power to use a portal once. The portal in a grid G(r, c) will send Homura to the grid below G (grid(r+1, c)), the grid on the right of G (grid(r, c+1)), or even G itself at respective probability (How evil the Boss Incubator is)!At the beginning Homura is in the top left corner of the LOOPS ((1, 1)), and the exit of the labyrinth is in the bottom right corner ((R, C)). Given the probability of transmissions of each portal, your task is help poor Homura calculate the EXPECT magic power she need to escape from the LOOPS.

Input

The first line contains two integers R and C (2 <= R, C <= 1000).The following R lines, each contains C*3 real numbers, at 2 decimal places. Every three numbers make a group. The first, second and third number of the cth group of line r represent the probability of transportation to grid (r, c), grid (r, c+1), grid (r+1, c) of the portal in grid (r, c) respectively. Two groups of numbers are separated by 4 spaces.It is ensured that the sum of three numbers in each group is 1, and the second numbers of the rightmost groups are 0 (as there are no grids on the right of them) while the third numbers of the downmost groups are 0 (as there are no grids below them).You may ignore the last three numbers of the input data. They are printed just for looking neat.The answer is ensured no greater than 1000000.Terminal at EOF

Output

A real number at 3 decimal places (round to), representing the expect magic power Homura need to escape from the LOOPS.

Sample Input

2 20.00 0.50 0.50 0.50 0.00 0.500.50 0.50 0.00 1.00 0.00 0.00

Sample Output

6.000

题意

有一个迷宫r行c列,开始在 [1,1] ,现在要走到 [r,c] ,在点 [x,y] 处我们有 P0 的概率保持原地不动,有 P1 的概率走到 [x][y+1] ,有 P2 的概率走到 [x+1][y] ,每次消耗2点魔力,求平均消耗多少魔力能走到 [r,c]

分析

我们假设 dp[i][j] 表示在点 [i,j] 到达 [r,c]

则从 dp[i][j] 可以到达 dp[i][j],dp[i][j+1],dp[i+1][j] ,对应概率分别为 P0,P1,P2

于是有 dp[i][j]=P0∗dp[i][j]+P1∗dp[i][j+1]+P2∗dp[i+1][j] ,移项化简可得 dp[i][j]=P1/(1−P0)∗dp[i][j+1]+P2/(1−P0)∗dp[i+1][j]+2/(1−P0)

根据状态转移方程我们可以看出,计算dp的时候只需要倒着推就可以了。

AC代码

#include #include#includeusing namespace std;#define MAXX 1005#define eps 1e-5double a[MAXX][MAXX][3];double dp[MAXX][MAXX];int r,c;void solve(){ dp[r][c]=0; for(int i=r; i>0; i--) for(int j=c; j>0; j--) { if(fabs(1-a[i][j][0])

版权声明:本文内容由网络用户投稿,版权归原作者所有,本站不拥有其著作权,亦不承担相应法律责任。如果您发现本站中有涉嫌抄袭或描述失实的内容,请联系我们jiasou666@gmail.com 处理,核实后本网站将在24小时内删除侵权内容。

上一篇:HDU 4586:Play the Dice (数学)
下一篇:2015年5种可能将要面临死亡的编程语言(编程性死亡与程序性死亡)
相关文章

 发表评论

暂时没有评论,来抢沙发吧~